package ch.zhaw.pm2.multichat.client;

import java.util.ArrayList;
import java.util.List;
import java.util.Objects;

public class ClientMessageList {
    private final List<Message> messages = new ArrayList<>();


    public void addMessage(Message message) {
	    messages.add(message);
    }

	public String getFilteredMessages(String filter) {
        String result = null;
		boolean showAll = filter == null || filter.isBlank();
		for(Message message : messages) {
			if(showAll || message.matchesFilter(filter))
			{
			    switch (message.getType()) {
                    case MESSAGE: result = result + String.format("[%s -> %s] %s\n", message.getSender(), message.getReceiver(), message.getText()); break;
                    case ERROR: result = result + String.format("[ERROR] %s\n", message.getText()); break;
                    case INFO: result = result + String.format("[INFO] %s\n", message.getText()); break;
                    default: result = result + String.format("[ERROR] %s\n", "Unexpected message type: " + message.getType());
                }
			}
		}
        return result;
	}

}
